<script lang="ts">
  import CardIcon from "./icons/CardIcon.svelte";

  import {
    CardType,
    getCardType,
    getRiceBallCount,
    getSingleScoreValue,
  } from "./utils";

  export let faceDown: boolean = false;
  export let card: CardId | undefined = undefined;

  $: cardTypeClass =
    (!faceDown && card !== undefined && getSuitClass(getCardType(card))) ?? "";

  $: riceBallCount = !faceDown && card !== undefined && getRiceBallCount(card);
  $: singleValue = !faceDown && card !== undefined && getSingleScoreValue(card);

  function getSuitClass(suit: CardType): string {
    switch (suit) {
      case CardType.Tempura:
        return "suit-a";
      case CardType.Dango:
        return "suit-b";
      case CardType.Gyoza:
        return "suit-c";
      case CardType.RiceBall:
        return "suit-d";
      case CardType.Sushi:
        return "suit-e";
      case CardType.Dessert:
        return "suit-f";
      case CardType.Tea:
        return "suit-g";
      case CardType.TakeoutBox:
        return "suit-h";
    }
  }
</script>

<div class="wrapper border shadow {cardTypeClass}" class:face-down={faceDown}>
  <div class="inner border">
    {#if !faceDown && card !== undefined}
      <div class="card-corner">
        {#if riceBallCount > 0 || singleValue > 0}
          <div class="card-value">
            <div class="card-value-inner">
              {#if riceBallCount > 0}
                {riceBallCount}
              {:else if singleValue > 0}
                {singleValue}
              {/if}
            </div>
          </div>
        {/if}
        <div class="card-icon">
          <CardIcon {card} />
        </div>
      </div>
      <div class="card-center">
        <CardIcon {card} />
      </div>
    {/if}
  </div>
</div>

<style>
  .wrapper {
    position: relative;
    height: 14em;
    width: 10em;

    border-radius: 7% / 5%;
    background: white;
  }

  .inner {
    position: absolute;
    border-radius: 3.5% / 2.5%;
    inset: 0.5em;
    background: linen;
  }

  .suit-e .inner,
  .suit-g .inner {
    background: rgb(255, 236, 172);
  }

  .suit-h .inner {
    background: rgb(196, 241, 241);
  }

  .suit-a .inner {
    background: rgb(236, 193, 236);
  }

  .suit-b .inner {
    background: rgb(212, 241, 193);
  }

  .suit-c .inner {
    background: rgb(189, 207, 248);
  }

  .suit-d .inner {
    background: rgb(228, 170, 168);
  }

  .suit-f .inner {
    background: rgb(255, 220, 229);
  }

  .face-down .inner {
    background: hsl(0, 45%, 55%);
  }

  .card-corner {
    position: absolute;
    top: 0.125em;
    left: 0.125em;

    font-size: 2em;
    display: grid;
    grid-template-rows: 1fr 1fr;
    place-content: center;
  }

  .card-value {
    position: relative;
    text-align: center;
    font-weight: bolder;
    color: whitesmoke;
    text-shadow: 0 0 0.1em #2227, 0 0 0.1em #2227, 0 0 0.1em #2227,
      0 0 0.1em #2227;
  }
  .card-value-inner {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }

  .card-center {
    font-size: 3.5em;
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }
</style>
